/*
 * =====================================================================================
 *
 *       Filename:  button.h
 *
 *    Description:  Button class
 *
 *        Version:  1.0
 *        Created:  12.05.2016 21:24:49
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Simon Ferber (https://www.ist-schlau.de), simon@ist-schlau.de
 *   Organization:  Kiwi Homebrew Computer
 *
 * =====================================================================================
 */

#ifndef BUTTON_H
#define BUTTON_H

#include "widget.h"
#include <cstddef>	// for NULL
#include <string>
#include <cstdbool>
extern "C" {
#include <v9990.h>
}

class button : public widget
{
public:
    button (uint16_t x=0, uint16_t y=0, uint16_t width=0, uint16_t height=0, std::string btn_caption="");
    ~button();
    void render (bool pressed=false);
    void doAction (action wAction);
    //void setCallback(void (*cb)(void));
    widget::action getlastAction();

private:
    bool pressed;
    std::string caption;
};

#endif
