/*
 * =====================================================================================
 *
 *       Filename:  hammacro.cpp
 *
 *    Description:  Ham Macro class
 *
 *        Version:  1.0
 *        Created:  22.05.2016 16:14:23
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Simon Ferber (https://www.ist-schlau.de), simon@ist-schlau.de
 *   Organization:  Kiwi Homebrew Computer
 *
 * =====================================================================================
 */

#include "hammacro.h"
#include <fstream>
#include <cstdlib>

macro::macro()
{
    std::ifstream input ("macros.ham");
    std::string line;
    std::string *newMacro;
    enum type {SEARCH, READ_MACRO} state;
    uint8_t pos;
    int macronumber;
    state = SEARCH;

    for (uint8_t i=0; i<12; i++) /* Create 12 empty macros for function key F1-F12 */
    {
        newMacro = new std::string;
        macros.push_back (newMacro);
    }

    while (std::getline (input, line))
    {
        //if(state == SEARCH && (line.find("[macro") != std::string::npos)) /* in seach mode and found "[macroX]" keyword */
        if ((line.find ("[macro") != std::string::npos)) /* in seach mode and found "[macroX]" keyword */
        {
            line.erase (0, 6); /*  remove "[macro" */
            pos = line.find ("]");

            if (pos != std::string::npos)
            {
                line.erase (pos, std::string::npos); /*  remove "]" keep macro # as string */
            }

            macronumber = strtol (line.c_str(),nullptr,10);
            state = READ_MACRO;
        }
        else
            if (state == READ_MACRO) /* previous [macroX] found, macro # in macronumber */
            {
                macros[macronumber-1]->append (line);
                *macros[macronumber-1] += '\n';
            }
    }

    for (uint8_t i=0; i<12; i++) /* Cut trailing empty lines of each macro */
    {
        while (!macros[i]->empty() && (*macros[i])[macros[i]->length()-1] == '\n')
        {
            macros[i]->erase (macros[i]->length()-1);
        }
    }
}

std::string *macro::getMacro (uint8_t number)
{
    return macros[number];
}
