/*
 * =====================================================================================
 *
 *       Filename:  label.cpp
 *
 *    Description:  Label class
 *
 *        Version:  1.0
 *        Created:  22.05.2016 13:57:53
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Simon Ferber (https://www.ist-schlau.de), simon@ist-schlau.de
 *   Organization:  Kiwi Homebrew Computer
 *
 * =====================================================================================
 */

#include "label.h"
#include "screen.h"

label::label (uint16_t x, uint16_t y, std::string lbl_caption)
{
    positionX = x;
    positionY = y;
    width = 0;
    height = 8;
    caption = lbl_caption;
    widgetType = type::Label;
    //pressed = false;
    callback = nullptr;
    render();
}

label::~label()
{
}

void label::render()
{
    VDP_BOX caption_box;
    uint8_t lbl_bgcolor;
    uint16_t capX = positionX;
    uint16_t capY = positionY;
    caption_box.left = capX;
    caption_box.top = capY;
    caption_box.width = 8;
    caption_box.height = 8;
    //lbl_bgcolor = v9990_GetColour(capX, capY) & 0xf0;
    //lbl_bgcolor |= (lbl_bgcolor>>4);
    lbl_bgcolor = 0x44;
    VDPWriteReg (VDP_FC,0x0000); // Foreground color
    WRITE_VDP (VDP_REGDAT,0x0000); // Foreground color
    VDPWriteReg (VDP_BC,lbl_bgcolor); // Background color
    WRITE_VDP (VDP_REGDAT,lbl_bgcolor); //Background color
    v9990_SetCmdWriteMask (0xffff);
    wait_vdp();

    for (std::string::iterator it=caption.begin(); it!=caption.end(); ++it)
    {
        v9990_CopyVRamCharToXY (&caption_box, VRAM_FONT + ((*it-32)<<3)); // -32 because font position != ASCII code
        caption_box.left += 8;
    }

    width = caption_box.left;
}
