/*
 * =====================================================================================
 *
 *       Filename:  splash.c++
 *
 *    Description:  Splash screen
 *
 *        Version:  1.0
 *        Created:  31.05.2016 12:59:12
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Simon Ferber (https://www.ist-schlau.de), simon@ist-schlau.de
 *   Organization:  Kiwi Homebrew Computer
 *
 * =====================================================================================
 */

#include "splash.h"

std::string splashscrn = "*    *                 *    \n"
"*    *  ****           *     *****\n"
"*    *      *  ** **  ***   *     *  * **  ** **\n"
"******  ***** *  *  *  *    *     *  **   *  *  *\n"
"*    * *    * *  *  *  *    ******   *    *  *  *\n"
"*    * *    * *  *  *  *     *       *    *  *  *\n"
"*    *  ****  *  *  *   ***   ****   *    *  *  *\n"
"\n"
"                                    Version 0.1\n"
"                        Written by Simon Ferber\n"
"\n"
"                                  Loading . . .";

void showSplash(uint16_t positionX, uint16_t positionY)
{
    VDP_BOX caption_box;
    uint8_t lbl_bgcolor;
    uint16_t capX = positionX;
    uint16_t capY = positionY;
    caption_box.left = capX;
    caption_box.top = capY;
    caption_box.width = 8;
    caption_box.height = 8;
    lbl_bgcolor = 0x44;
    VDPWriteReg (VDP_FC,0x0000); // Foreground color
    WRITE_VDP (VDP_REGDAT,0x0000); // Foreground color
    VDPWriteReg (VDP_BC,lbl_bgcolor); // Background color
    WRITE_VDP (VDP_REGDAT,lbl_bgcolor); //Background color
    v9990_SetCmdWriteMask (0xffff);
    wait_vdp();

    for (std::string::iterator it=splashscrn.begin(); it!=splashscrn.end(); ++it)
    {
        if(*it == '\n')
        {
            caption_box.left = capX;
            caption_box.top += 8;
        } else
        {
            v9990_CopyVRamCharToXY (&caption_box, VRAM_FONT + ((*it-32)<<3)); // -32 because font position != ASCII code
            caption_box.left += 8;
        }
    }
}
